/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { Series } from "./Series";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { Flattener } from "igniteui-react-core";
/**
 * @hidden
 */
export let BollingerBandsOverlay = /*@__PURE__*/ (() => {
    class BollingerBandsOverlay extends FinancialOverlay {
        constructor() {
            super();
            this.yb = 0;
            this.yc = 0;
            this.x9 = new List$1(Number_$type, 0);
            this.ya = new List$1(Number_$type, 0);
            this.ab = BollingerBandsOverlay.$;
            this.ud = new CategoryFrame(4);
            this.uf = new CategoryFrame(4);
            this.ub = new CategoryFrame(4);
        }
        o8(a, b, c, d) {
            if (this.vs().contains(b)) {
                this.x3 = false;
            }
            super.o8(a, b, c, d);
            switch (b) {
                case BollingerBandsOverlay.$$p[1]:
                    this.x3 = false;
                    this.pp(false);
                    break;
                case BollingerBandsOverlay.$$p[0]:
                    this.pp(false);
                    break;
            }
        }
        x4() {
            this.x9.clear();
            this.ya.clear();
            let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.vr), this.ye));
            let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.vr), this.ye));
            this.yc = 1.7976931348623157E+308;
            this.yb = -1.7976931348623157E+308;
            let c = true;
            let d = true;
            let e = this.yd;
            while (c || d) {
                if (a.moveNext()) {
                    this.x9.add(a.current);
                }
                else {
                    c = false;
                }
                if (b.moveNext()) {
                    this.ya.add(b.current);
                }
                else {
                    d = false;
                }
                if (c && d) {
                    this.yc = Math.min(this.yc, a.current - b.current * e);
                    this.yb = Math.max(this.yb, a.current + b.current * e);
                }
            }
            return true;
        }
        aq(a) {
            if (this.x9 == null || this.ya == null || a == null || this.c6 == null || a != this.uv) {
                return null;
            }
            let b = new AxisRange(this.yc, this.yb);
            return b;
        }
        xf(a, b) {
            super.xf(a, b);
            let c = b.by;
            let d = b.bx;
            let e = this.getEffectiveViewport1(b);
            let f = this.t9;
            let g = this.uv;
            let h = new ScalerParams(0, c, d, f.ch, e);
            let i = new ScalerParams(0, c, d, g.ch, e);
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = typeCast(ISortingAxis_$type, this.t9);
            if (j != null && j.i$b.count != this.c6.count) {
                return;
            }
            let k = 0;
            k = this.v0(c, d, e);
            if (!this.x3) {
                this.x3 = this.x4();
                if (this.uv != null) {
                    this.uv.c2(true);
                }
            }
            i.b = this.h2();
            let l = this.t9.em(2, h) - this.t9.em(1, h);
            for (let m = b.b0.c; m <= b.b0.d; ++m) {
                let n;
                if (j == null) {
                    n = b.b0.getBucket(m);
                }
                else {
                    let o = j.i$b._inner[m];
                    let p = j.i$d(o);
                    let q = this.x9._inner[m];
                    let r = this.ya._inner[m];
                    let s = q;
                    let t = r;
                    let u = p;
                    let v = 1;
                    while (m < b.b0.d) {
                        o = j.i$b._inner[m + 1];
                        u = j.i$d(o);
                        if (u - p > l) {
                            break;
                        }
                        m++;
                        s += this.x9._inner[m];
                        t += this.ya._inner[m];
                        v++;
                    }
                    s /= v;
                    t /= v;
                    let w = s - t * this.yd;
                    let x = s;
                    let y = s + t * this.yd;
                    let z = NaN;
                    if (!isNaN_(p)) {
                        z = this.t9.ej(p, h);
                    }
                    n = [z, w, x, y];
                }
                let aa = Math.max(1, l);
                if (!isNaN_(n[0]) && m * aa >= this.x5) {
                    if (this.t9 != null && typeCast(ISortingAxis_$type, this.t9) !== null) {
                        n[0] = n[0] + k;
                    }
                    else {
                        n[0] = f.ej(n[0], h) + k;
                    }
                    n[1] = g.ej(n[1], i);
                    n[2] = g.ej(n[2], i);
                    n[3] = g.ej(n[3], i);
                    a.f.add(n);
                }
            }
        }
        nj(a, b) {
            super.nj(a, b);
            let c = b;
            if (c != null) {
                c.b7();
            }
        }
        h9(a, b, c) {
            if (this.x9 == null) {
                return super.h9(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.cj);
            let e = this.v0(this.cj.by, this.cj.bx, d);
            let f = new ScalerParams(0, this.cj.by, this.cj.bx, this.t9.ch, d);
            f.c = this.cy.t2;
            return this.ib(this.x9, a, this.t9, f, e, runOn(this, this.vz), b, c);
        }
        jf(a, b) {
            if (this.x9 == null) {
                return super.jf(a, b);
            }
            return this.jg(a, b, this.t9, runOn(this, this.vz), this.x9);
        }
        jd(a, b) {
            if (this.x9 == null) {
                return super.jd(a, b);
            }
            return this.je(a, b, this.t9, runOn(this, this.vz), this.x9);
        }
        gl(a, b, c) {
            let d = super.gl(a, b, c);
            if (!this.vi(this.vs())) {
                d = false;
            }
            return d;
        }
        xh(a, b) {
            super.xh(a, b);
            let c = typeCast(BollingerBandsOverlayView.$, b);
            let d = this.getEffectiveViewport1(b);
            if (b.b3(a)) {
                c.b7();
                let e = a.f.count;
                let f = (g) => a.f._inner[g][0];
                let g = (h) => a.f._inner[e - 1 - h][0];
                let h = (i) => a.f._inner[i][1];
                let i = (j) => a.f._inner[j][2];
                let j = (k) => a.f._inner[e - 1 - k][3];
                c.b8(e, f, g, h, i, j);
                b.b5(a);
            }
            this.ui.a2(this, this.vh(), runOn(this, this.t1), this.v6(b), this.v8(b));
            let k = false;
            let l = this.ui.b;
            let m = a.f;
            let n = this.c6.count;
            if (l != null) {
                k = true;
            }
            if (k) {
                let o = new ScalerParams(0, b.by, b.bx, this.t9.ch, d);
                this.xe(m, -1, n, this.t9, o, b.q);
            }
            let p = c.cf;
            let q = c.cg;
            let r = c.ch;
            let s = c.ca;
            this.ui.ad(q, true, false, true, true);
            this.ui.an = null;
            this.ui.am = null;
            this.ui.ad(p, true, false, false, true);
            this.ui.ad(r, true, false, false, true);
            this.ui.ad(s, false, true, false, false);
            s._opacity = this.ui.j * this.hf;
        }
        cg() {
            return new BollingerBandsOverlayView(this);
        }
        o0(a) {
            super.o0(a);
            this.x8 = typeCast(BollingerBandsOverlayView.$, a);
        }
        v9() {
            return 3;
        }
        h2() {
            return Series.h4(this.x9, null);
        }
    }
    BollingerBandsOverlay.$t = /*@__PURE__*/ markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:yd:yh', [1, 2], 'Period:ye:yi', [1, 14]]);
    return BollingerBandsOverlay;
})();
/**
 * @hidden
 */
export let BollingerBandsBucketCalculator = /*@__PURE__*/ (() => {
    class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.a.b2.c6.count - 1);
            if (b <= c) {
                let d = this.f.b6.yd;
                let e = 0;
                let f = 0;
                let g = 0;
                for (let h = b; h <= c; ++h) {
                    if (!isNaN_(this.f.b6.x9._inner[h]) && !isNaN_(this.f.b6.ya._inner[h])) {
                        e += this.f.b6.x9._inner[h];
                        f += this.f.b6.ya._inner[h];
                        ++g;
                    }
                }
                if (g > 0) {
                    e = e / g;
                    f = f / g;
                    return [0.5 * (b + c), e - f * d, e, e + f * d];
                }
            }
            return [NaN, NaN, NaN, NaN];
        }
    }
    BollingerBandsBucketCalculator.$t = /*@__PURE__*/ markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
})();
/**
 * @hidden
 */
export let BollingerBandsOverlayView = /*@__PURE__*/ (() => {
    class BollingerBandsOverlayView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b6 = null;
            this.cb = new Polygon();
            this.ci = new Polyline();
            this.cj = new Polyline();
            this.ck = new Polyline();
            this.b9 = new Polygon();
            this.cc = new Polyline();
            this.cd = new Polyline();
            this.ce = new Polyline();
            this.b6 = a;
        }
        au() {
            super.au();
            if (!this.q) {
            }
        }
        b1() {
            return new BollingerBandsBucketCalculator(this);
        }
        b8(a, b, c, d, e, f) {
            for (let g of fromEnum(Flattener.d(a, b, d, this.e.hj))) {
                this.cb.an.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.ci.an.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
            for (let h of fromEnum(Flattener.d(a, b, e, this.e.hj))) {
                this.cj.an.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
            for (let i of fromEnum(Flattener.d(a, c, f, this.e.hj))) {
                this.cb.an.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ck.an.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
            this.as();
        }
        b7() {
            this.cb.an.clear();
            this.ci.an.clear();
            this.cj.an.clear();
            this.ck.an.clear();
            this.as();
        }
        get ca() {
            return this.cb;
        }
        get cf() {
            return this.ci;
        }
        get cg() {
            return this.cj;
        }
        get ch() {
            return this.ck;
        }
        be() {
            super.be();
            this.b9.an = this.cb.an;
            this.cc.an = this.ci.an;
            this.cd.an = this.cj.an;
            this.ce.an = this.ck.an;
            let a = this.br();
            this.b9._fill = a;
            this.b9._opacity = 1;
            this.cc._stroke = a;
            this.cc.ad = this.e.hk + 3;
            this.cd._stroke = a;
            this.cd.ad = this.e.hk + 3;
            this.ce._stroke = a;
            this.ce.ad = this.e.hk + 3;
        }
        a8(a, b) {
            super.a8(a, b);
            if (a.d) {
                if (b) {
                    a.u(this.b9);
                    a.v(this.cc);
                    a.v(this.cd);
                    a.v(this.ce);
                }
                else {
                    a.u(this.cb);
                    a.v(this.ci);
                    a.v(this.cj);
                    a.v(this.ck);
                }
            }
        }
        an(a) {
            super.an(a);
            this.e.a9.exportPolygonData(a, this.cb, "FillShape", ["Fill"]);
            this.e.a9.exportPolylineData(a, this.ci, "BottomLine", ["Lower", "Main"]);
            this.e.a9.exportPolylineData(a, this.cj, "CentralLine", ["Central"]);
            this.e.a9.exportPolylineData(a, this.ck, "TopLine", ["Upper"]);
        }
    }
    BollingerBandsOverlayView.$t = /*@__PURE__*/ markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
})();
